# Vivy

## Prerequisites

- [rust](https://www.rust-lang.org) compiler with version >= 1.70
- [cmake](https://cmake.org/) at least the version 3.18
- C++ compiler with [C++17 support](https://en.cppreference.com/w/cpp/17)
- [mpv](https://mpv.io/) development library
- [Qt6](https://www.qt.io/) development library: QtCore, QtWidgets, QtOpenGL, QtOpenGLWidgets.
- The AV libraries: libavutil libavcodec libavformat.
- Some unix utils, the `jq` binary, the `bash` shell.

## Build

Simply use cmake to build in another folder of the source folder:

```bash
cmake -Bbuild -DCMAKE_BUILD_TYPE=Release -DCMAKE_CXX_COMPILER=clang++ -DCMAKE_INSTALL_PREFIX=$HOME/.local -GNinja
ninja -Cbuild
ninja -Cbuild install
```

To develop Vivy, you need to pass the following argument to cmake: `-DCMAKE_BUILD_TYPE=Debug`. Also,
don't forget to copy the compile_commands.json file from the build folder into the project's root.

## Licence

- The C++ part of this software is licenced under [the LGPL v3.0 or latter](/LICENSE).
- The Rust part is under the [MIT license](/src/Rust/LICENSE.txt)
- The NotoSans fonts are distributed using the [OFL licence](/src/Rust/vvs_font/fonts/NotoSans-LICENCE-OFL.txt)
