#include "PreCompiledHeaders.hh"
#include "Lib/Document/VivyDocumentStore.hh"
#include "Lib/Document/VivyDocument.hh"

using namespace Vivy;

std::shared_ptr<VivyDocument>
VivyDocumentStore::newDocument(VivyDocument::Options opt)
{
    // Add the memory flag
    opt = static_cast<VivyDocument::Options>(opt | VivyDocument::MemoryDocumentCreation);

    const QString newDocName = newDocumentBaseName + QString::number(newDocumentNumber);
    auto ret                 = std::make_shared<VivyDocument>(newDocName, opt);
    newDocumentNumber++;

    if (ret) {
        const Uuid uuid = ret->getUuid();
        documents[uuid] = ret;
        logDebug() << "Create new document " << newDocName << " with uuid" << uuid;
        return ret;
    } else {
        logDebug() << "Failed to create new document " << newDocName;
        throw std::runtime_error("Failed to create the document");
    }
}
