#include "PreCompiledHeaders.hh"
#include "Lib/Video.hh"
#include "Lib/Utils.hh"

using namespace Vivy;

VideoStream::VideoStream(const AVCodec *streamCodec, AVFormatContext *formatArg, AVStream *streamArg,
                         int index)
    : Super(streamCodec, formatArg, streamArg, index)
{
}

QJsonObject
VideoStream::getProperties() const noexcept
{
    return Super::getProperties();
}

VideoContext::VideoContext(const QString &path)
    : Super(path)
{
}

QJsonDocument
VideoContext::getProperties() const noexcept
{
    return Super::getProperties();
}

QString
VideoContext::getElementName() const noexcept
{
    return "Video" + Super::getElementName();
}

int
VideoStream::getWidth() const noexcept
{
    return codecContext->width;
}

int
VideoStream::getHeight() const noexcept
{
    return codecContext->height;
}

qint64
VideoStream::getDuration() const noexcept
{
    return dataFormat->duration;
}

double
VideoStream::getFramesPerSecond() const noexcept
{
    return av_q2d(stream->r_frame_rate);
}
