# Vivy Script
The V4 of the Vivy Script utility to manipulate in an easy way ASS files.

# How to build and install
Like any rust project, simply run:

    cargo build --release
    cargo install --path vvs_cli
    vvcc --help

If you want to test it, from the root of the project you may replace any call
to `vvcc` by `cargo run --bin vvcc --`.

# Misc
## Manpage
To get the `vvcc` manpage, just run:

    vvcc --manpage | man -l -

To install it, you may run the following commands:

    mkdir -p $HOME/.local/share/man/man1/
    vvcc --manpage > $HOME/.local/share/man/man1/vvcc.1
    man vvcc

## Shell completion
To get the completion scripts to source you can use the following commands. You
can then source those files to get the completion working with your shell.

    mkdir -p $HOME/.local/share/completion/
    vvcc --shell bash > $HOME/.local/share/bash-completion/completions/vvcc
    vvcc --shell zsh  > $HOME/.local/share/zsh/site-functions/_vvcc

To get the completion working with the system, you can use the following commands:

    vvcc --shell bash > /usr/local/share/bash-completion/completions/vvcc
    vvcc --shell zsh  > /usr/local/share/zsh/site-functions/_vvcc

To visualize the dependency graph of VivyScript, use the command:

    cargo install cargo-depgraph
    cargo depgraph --build-deps --dedup-transitive-deps | dot -Tpdf | zathura -

## To test the project
The unit-tests can be ran on the project by running `cargo test`. The
integration tests and the unit-tests can be run together by using pcvs in the
[tests](tests) folder:

    pip install pcvs        -- Install PCVS
    (cd tests && pcvs run)  -- Run in the correct folder

You can also install PCVS by cloning the project and running `pip install .`
from its root.

# Licence
- The VVS project is under the MIT licence
- The NotoSans fonts are distributed using the [OFL licence](vvs_font/fonts/NotoSans-LICENCE-OFL.txt)
