/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#pragma once

/* Generated with cbindgen:0.26.0 */

namespace VVLib {

struct ASSContainer;

struct ASSLine;

/// Type used to describe an ASS style.
struct ASSStyle;

struct ASSSyllabe;

/// Represents a string slice, the user may not modify this slice, never! Note that the string is
/// not null terminated and may contains null bytes in it, use the len attribute to get the length
/// of this string and convert it to your linking.
///
/// # Safety
/// Note that you must always put unicode inside a string slice!
struct StringSlice
{
    uintptr_t len;
    const char *str;
};

extern "C" {

/// Get the name of the style.
///
/// # Safety
/// It is up to the user to ensure that the style is not dropped before the returned pointer.
StringSlice ASSStyleGetName(const ASSStyle *this_);

/// Get the number of lines in the container.
uintptr_t ASSContainerGetLinesCount(const ASSContainer *this_);

/// Get the number of syllabes in the line.
uintptr_t ASSLineGetSyllabesCount(const ASSLine *this_);

/// # Safety
/// It is up to the user to ensure that no aliasing is done or that the line is not removed
/// from the container before the pointer is dropped, or that the container is not dropped...
ASSLine *ASSContainerGetLineAt(ASSContainer *this_, uintptr_t idx);

/// # Safety
/// It is up to the user to ensure that no aliasing is done or that the syllabe is not removed
/// from the line before the pointer is dropped, or that the line is not removed from the
/// container...
ASSSyllabe *ASSLineGetSyllabeAt(ASSLine *this_, uintptr_t idx);

/// Tells whever a line is commented or not.
bool ASSLineIsCommented(const ASSLine *this_);

/// Gets the style of the line, or 'Default' if it was not found/specified.
StringSlice ASSLineGetStyle(const ASSLine *this_);

/// # Safety
/// The returned pointer must be freed
StringSlice ASSSyllabeGetContent(const ASSSyllabe *this_);

int64_t ASSSyllabeGetDuration(const ASSSyllabe *this_);

void ASSSyllabeSetDuration(ASSSyllabe *this_, int64_t duration);

/// Load the ASS from a file, returns nullptr if an error was encountred.
ASSContainer *ASSContainerFromFile(char *path);

/// # Safety
/// The name must be a valid CString (null terminated.)
ASSStyle *ASSContainerGetStyleByName(ASSContainer *this_, StringSlice name);

StringSlice ASSContainerGetStyleNameAt(const ASSContainer *this_, uintptr_t idx);

uintptr_t ASSContainerGetStylesCount(const ASSContainer *this_);

void ASSLineSetStartTime(ASSLine *this_, int64_t time);

void ASSLineSetFiniTime(ASSLine *this_, int64_t time);

int64_t ASSLineGetDuration(const ASSLine *this_);

int64_t ASSLineGetStartTime(const ASSLine *this_);

int64_t ASSLineGetFiniTime(const ASSLine *this_);

/// Drop the container. It is file to pass a null pointer to this function.
/// # Safety
/// The use must ensure that no dangling references remains...
void ASSContainerDrop(ASSContainer *this_);

} // extern "C"

} // namespace VVLib
