use thiserror::Error;

#[derive(Debug, Error)]
pub enum FontCreationError {
    #[error("ab_glyph error: {0}")]
    ABGlyphError(ab_glyph::InvalidFont),

    #[error("ttf-parser error: {0}")]
    TTFParserError(ttf_parser::FaceParsingError),
}

#[derive(Debug, Error)]
pub enum FontError {
    #[error("font has no name")]
    NoName,

    #[error("failed to outline glyph '{1}' for size {0}pt")]
    FailedToOutline(f64, char),

    #[error("can't outline an empty string")]
    EmptyStringToOutline,
}
