use super::*;

/// Unlike Lua, we require parens (`(` `)`) around tuples.
pub(crate) fn any_tuple<'a, 'b>(
    cache: Rc<RefCell<ASTStringCacheHandle<'b>>>,
) -> impl Fn(PSpan<'a>) -> VVParserError<'a, Vec<ASTExpr>> + 'b
where
    'b: 'a,
{
    move |input| {
        let (input, _) = multispace0(input)?;
        let (i, (head, mut tail)) = delimited(
            spaced_tag("("),
            separated_pair(
                expr(cache.clone()),
                spaced_tag(","),
                separated_list1(spaced_tag(","), expr(cache.clone())),
            ),
            preceded(opt(spaced_tag(",")), spaced_tag(")")),
        )(input)?;
        tail.insert(0, head);
        Ok((i, tail))
    }
}
