use cbindgen::{Braces, Language, Style};

fn main() {
    cbindgen::Builder::new()
        .with_crate(std::env::var("CARGO_MANIFEST_DIR").unwrap())
        .with_parse_deps(true)
        .with_parse_include(&["vvs_ass"])
        .with_documentation(true)
        .with_header("/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */")
        .with_language(Language::Cxx)
        .with_no_includes()
        .with_include_version(true)
        .with_line_length(120)
        .with_style(Style::Both)
        .with_cpp_compat(true)
        .with_pragma_once(true)
        .with_namespace("VVLib")
        .with_tab_width(4)
        .with_braces(Braces::NextLine)
        .generate()
        .expect("Failed to generate config")
        .write_to_file("../VVLib.hh");
}
