#[macro_export]
macro_rules! either {
    ($cond: expr => $then: expr ; $else: expr) => {{
        if $cond {
            $then
        } else {
            $else
        }
    }};
}

pub fn f64_epsilon_eq(a: f64, b: f64) -> bool {
    (a - b).abs() <= 10E-10
}

pub fn f32_epsilon_eq(a: f32, b: f32) -> bool {
    (a - b).abs() <= 10E-7
}
