#pragma once

#include "PreCompiledHeaders.hh"
#include "Lib/Utils.hh"

namespace Vivy
{
class AssLinesView final : public QTableView {
    Q_OBJECT
    VIVY_UNMOVABLE_OBJECT(AssLinesView)

private:
    class Delegate : public QStyledItemDelegate {
        VIVY_UNMOVABLE_OBJECT(Delegate)

    private:
        bool isHoveredRow(const QStyleOptionViewItem &, const QModelIndex &) const noexcept;

        int hoveredRow{ 0 };
        AssLinesView *tableView{ nullptr };

    public:
        Delegate(AssLinesView *, QWidget *parent = nullptr) noexcept;
        ~Delegate() noexcept override = default;

        void initStyleOption(QStyleOptionViewItem *option,
                             const QModelIndex &index) const noexcept override;

        void paint(QPainter *, const QStyleOptionViewItem &,
                   const QModelIndex &) const noexcept override;
        void onItemEntered(const QModelIndex &) noexcept;
    };

private:
    Delegate *delegate{ nullptr };

public:
    AssLinesView(QAbstractItemModel *, QWidget *parent = nullptr) noexcept;
    ~AssLinesView() noexcept override = default;

    void paintEvent(QPaintEvent *) noexcept override;

private:
    void mouseMoveEvent(QMouseEvent *) noexcept override;

protected slots:
    virtual void selectionChanged(const QItemSelection &selected,
                                  const QItemSelection &deselected) override;

signals:
    void hoverIndexChanged(QModelIndex);
    void updateSelectedLines(const QItemSelection &selected, const QItemSelection &deselected);
};
}
