#include "PreCompiledHeaders.hh"
#include "TimingBar.hh"

using namespace Vivy;

TimingBar::TimingBar(QLine line, QColor color) noexcept
    : QGraphicsLineItem(line)
{
    setPen(QPen(QBrush(color), bar_width, Qt::SolidLine, Qt::FlatCap));
    setFlags(QGraphicsItem::ItemIsMovable | QGraphicsItem::ItemSendsGeometryChanges);
    setAcceptHoverEvents(true);
    setCursor(Qt::PointingHandCursor);
}

/*
void TimingBar::mousePressEvent(QGraphicsSceneMouseEvent* event){
    fprintf(stderr, "CLICKED\n");
}
*/

QVariant
TimingBar::itemChange(GraphicsItemChange change, const QVariant &value) noexcept
{
    if (change == ItemPositionChange) {
        return QPointF(value.toPointF().x(), 0);
    }
    return QGraphicsLineItem::itemChange(change, value);
}

/*
void TimingBar::hoverEnterEvent (QGraphicsSceneHoverEvent *event){
  QGraphicsItem::hoverEnterEvent(event);
  QApplication::setOverrideCursor(Qt::PointingHandCursor);
}

void TimingBar::hoverLeaveEvent (QGraphicsSceneHoverEvent *event){
  QGraphicsItem::hoverLeaveEvent(event);
  QApplication::setOverrideCursor(Qt::ArrowCursor);
}
*/
