#include "TimingCursor.hh"
#include "TimingParams.hh"

using namespace Vivy;

TimingCursor::TimingCursor()
    : QGraphicsItem()
{
    setZValue(Z_CURSOR_BAR);
}

QRectF
TimingCursor::boundingRect() const
{
    return QRectF(-maxWidth, 0, maxWidth * 2, static_cast<int>(getTimingParam()->audioHeight()));
}

void
TimingCursor::paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
{
    painter->drawLine(0, 0, 0, static_cast<int>(getTimingParam()->audioHeight()));

    QRectF textRectangle = textRect;
    QPointF sceneLeft    = mapFromScene(QPointF(0, 0));
    QPointF sceneRight   = mapFromScene(QPointF(scene()->sceneRect().right(), 0));
    getTimingParam()->adjustFlip(&textRectangle, sceneLeft.rx(), sceneRight.rx());

    //painter->drawRect(textRectangle);
    painter->drawText(textRectangle, Qt::AlignHCenter | Qt::AlignTop, cursorTime);
}

void
TimingCursor::setTime(QString str) noexcept
{
    cursorTime = str;
}

void
TimingCursor::onParamsChanged()
{
    // TODO : remove 10/20 magic numbers
    textRect = QRectF(0, 10, maxWidth, static_cast<int>(getTimingParam()->audioHeight() - 20));
}
