#pragma once

#include <PreCompiledHeaders.hh>

#include "Rust/VVLib.hh"
#include "TimingSeparator.hh"
#include "TimingSyl.hh"

namespace Vivy
{
class TimingLine final : public QGraphicsObject {
    Q_OBJECT
public:
    explicit TimingLine(VVLib::ASSLine[], qint64, QGraphicsItem * = nullptr);

    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;

private:
    VVLib::ASSLine *const line;
    QVector<TimingSeparator *> seps;
    QVector<TimingSyl *> timingSyls;
    qint64 lineIndex;

    qreal tempOffset{ 0 };

public:
    qreal requestMove(qint64, qreal);

signals:
    void lineChanged(qint64);

public slots:
    void timingSeparatorHasChanged(qint64, qreal);
    void sepEnterPress(qint64);
    void sepExitPress(qint64);
    void onParamsChanged();
};

}
