#pragma once

#include "PreCompiledHeaders.hh"

namespace Vivy
{
class TimingLine;

class TimingSeparator final : public QGraphicsObject {
    Q_OBJECT
public:
    enum class SeparatorStyle { Start, Middle, End };

public:
    explicit TimingSeparator(qint64, qint64, SeparatorStyle, TimingLine *);

    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;

private:
    SeparatorStyle style;
    int widthPaw = 5;
    QPen pen;
    qint64 sepIndex;
    TimingLine *parentTimingLine;

    bool inhibMove{ false };

signals:
    void positionChanged(qint64, qreal);
    void enterPress(qint64);
    void exitPress(qint64);

protected:
    QVariant itemChange(GraphicsItemChange change, const QVariant &value) noexcept override;
    void mousePressEvent(QGraphicsSceneMouseEvent *event) override;
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *event) override;

public:
    void silentlySetPos(qreal, qreal);
    void silentlyMoveBy(qreal, qreal);
};

}
