#include "TimingSyl.hh"
#include "TimingParams.hh"
#include "TimingSeparator.hh"

using namespace Vivy;

TimingSyl::TimingSyl(VVLib::ASSSyllabe syl_[], qint64 startTime, QGraphicsItem *parent)
    : QGraphicsObject(parent)
    , syl(syl_)
{
    setZValue(Z_LINE_SYL_TEXT);
    setPos(static_cast<qreal>(getTimingParam()->posFromMs(startTime)), 0.0);
}

QRectF
TimingSyl::boundingRect() const
{
    const qreal dur = static_cast<qreal>(VVLib::ASSSyllabeGetDuration(syl));
    return QRectF(0, 0, dur, static_cast<qreal>(getTimingParam()->audioHeight()));
}

void
TimingSyl::paint(QPainter *painter, const QStyleOptionGraphicsItem *, QWidget *)
{
    const auto str = VVLib::ASSSyllabeGetContent(syl);
    painter->drawText(boundingRect(), Qt::AlignCenter,
                      QString::fromUtf8(str.str, static_cast<qsizetype>(str.len)));
}

void
TimingSyl::setLen(qint64 len)
{
    prepareGeometryChange();
    VVLib::ASSSyllabeSetDuration(syl, len);
}
