#pragma once

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "Lib/Utils.hh"
#include "TimingBar.hh"
#include "TimingScene.hh"

namespace Vivy
{
class TimingView final : public QGraphicsView {
    Q_OBJECT

    static inline constexpr qint64 wheelAngleToScrollRatio = 5;
    TimingScene *currentScene{ nullptr };
    AudioContext::StreamPtr audioStream;

public:
    static inline constexpr QColor startColour = QColor(127, 0, 127);
    static inline constexpr QColor endColour   = QColor(0, 127, 0);

    explicit TimingView(QGraphicsScene *, QImage, AudioContext::StreamPtr,
                        QWidget * = nullptr) noexcept;

    ~TimingView() noexcept override = default;

    void wheelEvent(QWheelEvent *) noexcept override;

public slots:
    void moveScrollBarToBottom(qint64, qint64) noexcept;
};
}
