#pragma once

#include "PreCompiledHeaders.hh"
#include "UI/Utils.hh"

namespace Vivy
{
class UnclosableDockWidget final : public QDockWidget {
    Q_OBJECT
    VIVY_UNMOVABLE_OBJECT(UnclosableDockWidget)

public:
    explicit UnclosableDockWidget(const QString &, QWidget *parent) noexcept;
    ~UnclosableDockWidget() noexcept override;
    void allowClose() noexcept;

protected:
    void closeEvent(QCloseEvent *event) noexcept override;

private:
    bool allowedToClose{ false };
};
}
